<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex49.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex49.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex49.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex49.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 49: Making Sentences</h1>
                <p>What we should be able to get from our little game lexicon scanner is a list that looks like this:</p>
<div class="highlight"><pre><span></span><a name="python--ex49_pycon.py-idio-pycon-pyg.html-1"></a><span class="go">Python 2.7.11 (default, Jan 22 2016, 23:30:40) </span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-2"></a><span class="go">[GCC 4.2.1 Compatible Apple LLVM 7.0.2 (clang-700.1.81)] on darwin</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-3"></a><span class="go">Type &quot;help&quot;, &quot;copyright&quot;, &quot;credits&quot; or &quot;license&quot; for more information.</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-4"></a><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">ex48</span> <span class="kn">import</span> <span class="n">lexicon</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-5"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;go north&quot;</span><span class="p">)</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-6"></a><span class="go">[(&#39;verb&#39;, &#39;go&#39;), (&#39;direction&#39;, &#39;north&#39;)]</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-7"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;kill the princess&quot;</span><span class="p">)</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-8"></a><span class="go">[(&#39;verb&#39;, &#39;kill&#39;), (&#39;stop&#39;, &#39;the&#39;), (&#39;noun&#39;, &#39;princess&#39;)]</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-9"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;eat the bear&quot;</span><span class="p">)</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-10"></a><span class="go">[(&#39;verb&#39;, &#39;eat&#39;), (&#39;stop&#39;, &#39;the&#39;), (&#39;noun&#39;, &#39;bear&#39;)]</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-11"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;open the door and smack the bear in the nose&quot;</span><span class="p">)</span>
<a name="python--ex49_pycon.py-idio-pycon-pyg.html-12"></a><span class="go">[(&#39;error&#39;, &#39;open&#39;), (&#39;stop&#39;, &#39;the&#39;), (&#39;error&#39;, &#39;door&#39;), (&#39;error&#39;, &#39;and&#39;), (&#39;error&#39;, &#39;smack&#39;), (&#39;stop&#39;, &#39;the&#39;), (&#39;noun&#39;, &#39;bear&#39;), (&#39;stop&#39;, &#39;in&#39;), (&#39;stop&#39;, &#39;the&#39;), (&#39;error&#39;, &#39;nose&#39;)]</span>
</pre></div><p>Now let us turn this into something the game can work with, which would be some kind of <tt class="docutils literal">Sentence</tt> class.</p>
<p>If you remember grade school, a sentence can be a simple structure like:</p>
<blockquote>
Subject Verb Object</blockquote>
<p>Obviously it gets more complex than that, and you probably did many days of annoying sentence graphs for English class.  What we want is to turn the above lists of tuples into a nice Sentence object that has subject, verb, and object.</p>
<div class="section" id="match-and-peek">
<h1>Match and Peek</h1>
<p>To do this we need four tools:</p>
<ol class="arabic simple">
<li>A way to loop through the list of scanned words.  That's easy.</li>
<li>A way to &quot;match&quot; different types of tuples that we expect in our Subject Verb Object setup.</li>
<li>A way to &quot;peek&quot; at a potential tuple so we can make some decisions.</li>
<li>A way to &quot;skip&quot; things we do not care about, like stop words.</li>
<li>A Sentence object to put the results in.</li>
</ol>
<p>We will be putting these functions in a module named <tt class="docutils literal">ex48.parser</tt> in a file named <tt class="docutils literal">ex48/parser.py</tt> in order to test it.  We use the <tt class="docutils literal">peek</tt> function to say look at the next element in our tuple list, and then match to take one off and work with it.</p>
</div>
<div class="section" id="the-sentence-grammar">
<h1>The Sentence Grammar</h1>
<p>Before you can write the code you need to understand how a basic English sentence grammar works.  In our parser we want to produce a <tt class="docutils literal">Sentence</tt> object that has three attributes:</p>
<dl class="docutils">
<dt>Sentence.subject</dt>
<dd>This is the subject of any sentence, but could default to &quot;player&quot; most of the time since a sentence of, &quot;run north&quot; is implying &quot;player run north&quot;.  This will be a noun.</dd>
<dt>Sentence.verb</dt>
<dd>This is the action of the sentence. In &quot;run north&quot; it would be &quot;run&quot;.  This will be a verb.</dd>
<dt>Sentence.object</dt>
<dd>This is another noun that refers to what the verb is done on.  In our game we separate out directions which would also be objects.  In &quot;run north&quot; the word &quot;north&quot; would be the object.  In &quot;hit bear&quot; the word &quot;bear&quot; would be the object.</dd>
</dl>
<p>Our parser then has to use the functions we described and given a scanned sentence, convert it into an <tt class="docutils literal">List</tt> of <tt class="docutils literal">Sentence</tt> objects to match the input.</p>
</div>
<div class="section" id="a-word-on-exceptions">
<h1>A Word On Exceptions</h1>
<p>You briefly learned about exceptions but not how to raise them.  This code demonstrates how to do that with the <tt class="docutils literal">ParserError</tt> at the top.  Notice that it uses classes to give it the type of <tt class="docutils literal">Exception</tt>.  Also notice the use of the <tt class="docutils literal">raise</tt> keyword to raise the exception.</p>
<p>In your tests, you will want to work with these exceptions, which I'll show you how to do.</p>
</div>
<div class="section" id="the-parser-code">
<h1>The Parser Code</h1>
<p>If you want an extra challenge, stop right now and try to write this based on just my description.  If you get stuck you can come back and see how I did it, but trying to implement the parser yourself is good practice.  I will now walk through the code so you can enter it into your <tt class="docutils literal">ex48/parser.py</tt>.  We start the parser with the exception we need for a parsing error:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">class</span> <span class="nc">ParserError</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>    <span class="k">pass</span>
</pre></div>
</td></tr></table><p>This is how you make your own <tt class="docutils literal">ParserError</tt> exception class you can throw.  Next we need the <tt class="docutils literal">Sentence</tt> object we'll create:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5
6
7</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Sentence</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>
<a name="python--ex48--parser.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">subject</span><span class="p">,</span> <span class="n">verb</span><span class="p">,</span> <span class="n">obj</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-4"></a>        <span class="c1"># remember we take (&#39;noun&#39;,&#39;princess&#39;) tuples and convert them</span>
<a name="python--ex48--parser.py-idio.html-5"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">subject</span> <span class="o">=</span> <span class="n">subject</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
<a name="python--ex48--parser.py-idio.html-6"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">verb</span> <span class="o">=</span> <span class="n">verb</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
<a name="python--ex48--parser.py-idio.html-7"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">object</span> <span class="o">=</span> <span class="n">obj</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
</pre></div>
</td></tr></table><p>There's nothing special about this code so far. You're just making simple classes.</p>
<p>In our description of the problem we need a function that can peek at a list of words and return what type of word it is:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5
6</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">def</span> <span class="nf">peek</span><span class="p">(</span><span class="n">word_list</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>    <span class="k">if</span> <span class="n">word_list</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-3"></a>        <span class="n">word</span> <span class="o">=</span> <span class="n">word_list</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
<a name="python--ex48--parser.py-idio.html-4"></a>        <span class="k">return</span> <span class="n">word</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
<a name="python--ex48--parser.py-idio.html-5"></a>    <span class="k">else</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-6"></a>        <span class="k">return</span> <span class="bp">None</span>
</pre></div>
</td></tr></table><p>We need this function because we'll have to make decisions about what kind of sentence we're dealing with based on what the next word is, and then we can call another function to consume that word and carry on.</p>
<p>To consume a word we use a the <tt class="docutils literal">match</tt> function, which confirms that the expected word is the right type, takes it off the list, and returns the word.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">def</span> <span class="nf">match</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="n">expecting</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>    <span class="k">if</span> <span class="n">word_list</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-3"></a>        <span class="n">word</span> <span class="o">=</span> <span class="n">word_list</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-4"></a>
<a name="python--ex48--parser.py-idio.html-5"></a>        <span class="k">if</span> <span class="n">word</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="n">expecting</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-6"></a>            <span class="k">return</span> <span class="n">word</span>
<a name="python--ex48--parser.py-idio.html-7"></a>        <span class="k">else</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-8"></a>            <span class="k">return</span> <span class="bp">None</span>
<a name="python--ex48--parser.py-idio.html-9"></a>    <span class="k">else</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-10"></a>        <span class="k">return</span> <span class="bp">None</span>
</pre></div>
</td></tr></table><p>Again, fairly simple but make sure you understand this code but also <em>why</em> I'm doing it this way.  I need to peek at words in the list to decide what kind of sentence I'm dealing with, and then I need to match those words to create my <tt class="docutils literal">Sentence</tt>.</p>
<p>The last thing I need is a way to skip words that aren't useful to the <tt class="docutils literal">Sentence</tt>.  These are the words labeled &quot;stop words&quot; (type 'stop') that are words like &quot;the&quot;, &quot;and&quot;, and &quot;a&quot;.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">def</span> <span class="nf">skip</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="n">word_type</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>    <span class="k">while</span> <span class="n">peek</span><span class="p">(</span><span class="n">word_list</span><span class="p">)</span> <span class="o">==</span> <span class="n">word_type</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-3"></a>        <span class="n">match</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="n">word_type</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>Remember that <tt class="docutils literal">skip</tt> doesn't skip one word, it skips as many words of that type as it finds.  This makes it so if someone types, &quot;scream at the bear&quot; you get &quot;scream&quot; and &quot;bear.&quot;</p>
<p>That's our basic set of parsing functions, and with that we can actually parse just about any text we want.  Our parser is very simple though, so the remaining functions are short.</p>
<p>First we can handle parsing a verb:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5
6
7</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">def</span> <span class="nf">parse_verb</span><span class="p">(</span><span class="n">word_list</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>    <span class="n">skip</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="s1">&#39;stop&#39;</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-3"></a>
<a name="python--ex48--parser.py-idio.html-4"></a>    <span class="k">if</span> <span class="n">peek</span><span class="p">(</span><span class="n">word_list</span><span class="p">)</span> <span class="o">==</span> <span class="s1">&#39;verb&#39;</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-5"></a>        <span class="k">return</span> <span class="n">match</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="s1">&#39;verb&#39;</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-6"></a>    <span class="k">else</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-7"></a>        <span class="k">raise</span> <span class="n">ParserError</span><span class="p">(</span><span class="s2">&quot;Expected a verb next.&quot;</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>We skip any stop words, then peek ahead to make sure the next word is a &quot;verb&quot; type.  If it's not then raise the <tt class="docutils literal">ParserError</tt> to say why.  If it is a &quot;verb&quot; then match it, which takes it off the list.  A similar function handles sentence objects:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">def</span> <span class="nf">parse_object</span><span class="p">(</span><span class="n">word_list</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>    <span class="n">skip</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="s1">&#39;stop&#39;</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-3"></a>    <span class="n">next_word</span> <span class="o">=</span> <span class="n">peek</span><span class="p">(</span><span class="n">word_list</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-4"></a>
<a name="python--ex48--parser.py-idio.html-5"></a>    <span class="k">if</span> <span class="n">next_word</span> <span class="o">==</span> <span class="s1">&#39;noun&#39;</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-6"></a>        <span class="k">return</span> <span class="n">match</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="s1">&#39;noun&#39;</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-7"></a>    <span class="k">elif</span> <span class="n">next_word</span> <span class="o">==</span> <span class="s1">&#39;direction&#39;</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-8"></a>        <span class="k">return</span> <span class="n">match</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="s1">&#39;direction&#39;</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-9"></a>    <span class="k">else</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-10"></a>        <span class="k">raise</span> <span class="n">ParserError</span><span class="p">(</span><span class="s2">&quot;Expected a noun or direction next.&quot;</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>Again, skip the stop words, peek ahead, and decide if the sentence is correct based on what's there.  In the <tt class="docutils literal">parse_object</tt> function though we need to handle both &quot;noun&quot; and &quot;direction&quot; words as possible objects.  Subjects are then similar again, but since we want to handle the implied &quot;player&quot; noun, we have to use <tt class="docutils literal">peek</tt>:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">def</span> <span class="nf">parse_subject</span><span class="p">(</span><span class="n">word_list</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>    <span class="n">skip</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="s1">&#39;stop&#39;</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-3"></a>    <span class="n">next_word</span> <span class="o">=</span> <span class="n">peek</span><span class="p">(</span><span class="n">word_list</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-4"></a>
<a name="python--ex48--parser.py-idio.html-5"></a>    <span class="k">if</span> <span class="n">next_word</span> <span class="o">==</span> <span class="s1">&#39;noun&#39;</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-6"></a>        <span class="k">return</span> <span class="n">match</span><span class="p">(</span><span class="n">word_list</span><span class="p">,</span> <span class="s1">&#39;noun&#39;</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-7"></a>    <span class="k">elif</span> <span class="n">next_word</span> <span class="o">==</span> <span class="s1">&#39;verb&#39;</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-8"></a>        <span class="k">return</span> <span class="p">(</span><span class="s1">&#39;noun&#39;</span><span class="p">,</span> <span class="s1">&#39;player&#39;</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-9"></a>    <span class="k">else</span><span class="p">:</span>
<a name="python--ex48--parser.py-idio.html-10"></a>        <span class="k">raise</span> <span class="n">ParserError</span><span class="p">(</span><span class="s2">&quot;Expected a verb next.&quot;</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>With that all out of the way and ready, our final <tt class="docutils literal">parse_sentence</tt> function is very simple:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5
6</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48--parser.py-idio.html-1"></a><span class="k">def</span> <span class="nf">parse_sentence</span><span class="p">(</span><span class="n">word_list</span><span class="p">):</span>
<a name="python--ex48--parser.py-idio.html-2"></a>    <span class="n">subj</span> <span class="o">=</span> <span class="n">parse_subject</span><span class="p">(</span><span class="n">word_list</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-3"></a>    <span class="n">verb</span> <span class="o">=</span> <span class="n">parse_verb</span><span class="p">(</span><span class="n">word_list</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-4"></a>    <span class="n">obj</span> <span class="o">=</span> <span class="n">parse_object</span><span class="p">(</span><span class="n">word_list</span><span class="p">)</span>
<a name="python--ex48--parser.py-idio.html-5"></a>
<a name="python--ex48--parser.py-idio.html-6"></a>    <span class="k">return</span> <span class="n">Sentence</span><span class="p">(</span><span class="n">subj</span><span class="p">,</span> <span class="n">verb</span><span class="p">,</span> <span class="n">obj</span><span class="p">)</span>
</pre></div>
</td></tr></table></div>
<div class="section" id="playing-with-the-parser">
<h1>Playing With The Parser</h1>
<p>To see how this works, you can play with it like this:</p>
<div class="highlight"><pre><span></span><a name="python--ex49a_pycon.py-idio-pycon-pyg.html-1"></a><span class="go">Python 2.7.11 (default, Jan 22 2016, 23:30:40) </span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-2"></a><span class="go">[GCC 4.2.1 Compatible Apple LLVM 7.0.2 (clang-700.1.81)] on darwin</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-3"></a><span class="go">Type &quot;help&quot;, &quot;copyright&quot;, &quot;credits&quot; or &quot;license&quot; for more information.</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-4"></a><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">ex48.parser</span> <span class="kn">import</span> <span class="o">*</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-5"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">x</span> <span class="o">=</span> <span class="n">parse_sentence</span><span class="p">([(</span><span class="s1">&#39;verb&#39;</span><span class="p">,</span><span class="s1">&#39;run&#39;</span><span class="p">),</span> <span class="p">(</span><span class="s1">&#39;direction&#39;</span><span class="p">,</span><span class="s1">&#39;north&#39;</span><span class="p">)])</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-6"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">x</span><span class="o">.</span><span class="n">subject</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-7"></a><span class="go">&#39;player&#39;</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-8"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">x</span><span class="o">.</span><span class="n">verb</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-9"></a><span class="go">&#39;run&#39;</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-10"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">x</span><span class="o">.</span><span class="n">object</span>
<a name="python--ex49a_pycon.py-idio-pycon-pyg.html-11"></a><span class="go">&#39;north&#39;</span>
</pre></div><p>Try to map sentences to the correct pairings in a sentence.  For example, how would you say, &quot;the bear run south?&quot;</p>
</div>
<div class="section" id="what-you-should-test">
<h1>What You Should Test</h1>
<p>For Exercise 49, write a complete test that confirms everything in this code is working.  Put the test in <tt class="docutils literal">tests/parser_tests.py</tt> similar to the test file from the last exercise. That includes making exceptions happen by giving the parser bad sentences.</p>
<p>Check for an exception by using the function <tt class="docutils literal">assert_raises</tt> from the <tt class="docutils literal">nose</tt> documentation.  Learn how to use this so you can write a test that is <em>expected</em> to fail, which is very important in testing.  Learn about this function (and others) by reading the nose documentation.</p>
<p>When you are done, you should know how this bit of code works and how to write a test for other people's code even if they do not want you to.  Trust me, it's a very handy skill to have.</p>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Change the <tt class="docutils literal">parse_</tt> methods and try to put them into a class rather than be just methods.  Which design do you like better?</li>
<li>Make the parser more error-resistant so that you can avoid annoying your users if they type words your lexicon doesn't understand.</li>
<li>Improve the grammar by handling more things like numbers.</li>
<li>Think about how you might use this Sentence class in your game to do more fun things with a user's input.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>I can't seem to make <tt class="docutils literal">assert_raises</tt> work right.</dt>
<dd>Make sure you are writing <tt class="docutils literal">assert_raises(exception, callable, parameters)</tt> and <em>not</em> writing <tt class="docutils literal">assert_raises(exception, callable(parameters))</tt>.  Notice how the second form is calling the function then passing the result to <tt class="docutils literal">assert_raises</tt>, which is <em>wrong</em>.  You have to pass the function to call <em>and</em> its arguments to <tt class="docutils literal">assert_raises</tt>.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex49.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex49.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
